# Contributing to pickled_cucumber 🎨

Thanks for opening the CONTRIBUTING file.
pickled_cucumber is open source and will continue to be.
If you want to make a suggestion, open an issue of propose a change, please read the following lines.

## Code of conduct 👥

Before posting anything on this repository, please read the [CODE_OF_CONDUCT.md](CODE_OF_CONDUCT.md)

## Open an issue 📝

For any suggestion, issue or question, please fill an issue

[https://github.com/PiotrFLEURY/pickled_cucumber/issues/new/choose](https://github.com/PiotrFLEURY/pickled_cucumber/issues/new/choose)

Please provide the more context as possible in order to plainly understand your purpose and being able to address it.

## Propose a change 🏗️

> NOTICE
>
> Any change must respect the [conventional commits convention](https://www.conventionalcommits.org/en/v1.0.0/)

To propose any change please use the following process :

1. `Fork` this repository
2. Create a `new branch`
3. `Make` your changes
4. `Create new tests` and `update existing` ones if required
5. Update the `documentation`
6. `Commit` the changes on your branch
7. Propose a `pull request` to the `main` branch and fill the description
8. Ensure `CI checks` are successful - update your changes following the CI indication if needed
9. Wait for a `code review`
10. When you got a `LGTM` your changes are ready to be merged 🎉
